# (c) cavaliba.com - home - tasks.py

from time import sleep

from django.core import management

from celery import shared_task

from app_home.configuration import get_configuration
import app_home.cache as cache

from app_home.log import log, DEBUG, INFO, WARNING, ERROR, CRITICAL

                
from .log import purge


#@app.task
@shared_task
def log_purge():

    aaa = None
    count = purge(aaa=aaa)
    log(INFO, aaa=aaa, app="cron", view="log", action="purge", status="OK", data=f"{count} removed")


# V3.15.11
@shared_task
def clear_expired_sessions():
    management.call_command('clearsessions')
    aaa = None
    log(INFO, aaa=aaa, app="cron", view="session", action="clear", status="OK", data=f"cleared expired sessions")