# (c) cavaliba.com - test_home 

from io import StringIO
#import io



from django.test import TestCase, override_settings
from django.urls import reverse
from django.core.management import call_command


import app_home.cache as cache
from app_home.configuration import get_configuration



class ConfTest(TestCase):

    # @classmethod
    # def setUpTestData(cls):
    #     cavaliba_update(verbose=False)


    fixtures = ["test"]
    def setUp(self):
        cache.init()


    def test_test(self):
        self.assertEqual(True, True)


    def test_get_configuration(self):

        r = get_configuration("home", "GLOBAL_APPNAME")
        self.assertEqual(r, 'Cavaliba')

        r = get_configuration(keyname="GLOBAL_APPNAME")
        self.assertEqual(r, 'Cavaliba')

        r = get_configuration("env", "CAVALIBA_AUTH_MODE")
        #self.assertEqual(r, 'local')
        self.assertIn(r,["local","oauth2","basic","forced"])


    def test_conf_no_skip_public(self):
        r = get_configuration("sirene", "PUBLIC_SKIP_TO_TRUSTED")
        self.assertEqual(r, 'no')



# ------------
# commands
# ------------

    def test_check_command(self):

        output = StringIO()
        err = StringIO()
        call_command("check", verbosity=2, stdout=output)
        assert("System check identified no issues" in output.getvalue())    


    def test_update_command(self):

        output = StringIO()
        err = StringIO()
        call_command("cavaliba","update", verbosity=2, stdout=output)
        assert("update done" in output.getvalue())    


    def test_conf_command(self):

        output = StringIO()
        err = StringIO()
        call_command("cavaliba", "conf", verbosity=2, stdout=output)
        assert("conf done" in output.getvalue())    


    def test_log_purge_command(self):

        output = StringIO()
        err = StringIO()
        call_command("cavaliba","log" ,"--log_purge", verbosity=2, stdout=output)
        assert("log done" in output.getvalue())    


    def test_load_command_unknown(self):

        output = StringIO()
        err = StringIO()
        call_command("cavaliba", "load", "unknown_file", verbosity=2, stdout=output, stderr=err)
        assert("load done" in output.getvalue())
        assert("SKIP - Unknown filename" in err.getvalue())



